echo "Extracting joinr (with variable substitutions)"
: This section of the file will have variable substitutions done on it.
: Move anything that needs config subs from !NO!SUBS! section to !GROK!THIS!.
: Protect any dollar signs and backticks that you do not want interpreted
: by putting a backslash in front.  You may delete these comments.
$spitshell >joinr <<!GROK!THIS!
$startsh
#
# joinr - Extract and glue together mailsplit transmissions
# @(#)joinr.SH    2.6    88/08/20       M F Wyle

############################################################################
# These commands and paths should be configured for your machine/site

BA=$basename     # chop off leading path *
CAT=$cat         # Concatenate And prinT *
TA=$tar          # Archive command *
TAO="xvf"        # options to send to archive command to extract data
RM="$rm -f"      # Remove command
SED=$sed         # Stream editor *
MV=$mv           # Rename command *
GREP=$grep       # get regular expression *
HEAD=$head       # Get initial part of file (for a non-UCB sys use cat) *
PWD=$pwd         # Print working directory *
touch=$touch     # the touch command
uncompress=$uncompress
uudecode=$uudecode
CE=$CE           # compress'd file name extension

TD=$TD            # temp directory
T1=$TD/x_\$\$_    # temp file for pieces
T2=$TD/g_\$\$     # temp file for garbage
T3=$TD/f_\$\$     # temp file for archive
T4=$TD/p_\$\$     # file containing the extract awk script

!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
$spitshell >>joinr <<'!NO!SUBS!'
##############################################################################
# You might want to change these, but it's not likely.

ME=`$BA $0`        # This program's name
VE="2.6 88/08/20"  # Version of this program

##############################################################################
# Hacker city

echo " "
echo "$ME version $VE    (C) 1988     M F Wyle" 1>&2
echo " "

echo "...initializing, preparing to extract..."
if test ! -t 0; then
  echo "...found data on standard in; ignoring command line..."
else
  echo "...standard input empty, looking for files on command line..."
  case $# in
    0) echo " "
       echo "Usage:   $ME [ < ] file(s)"
       echo "Example: $ME < p1of2 p2of2"
       echo " "
       exit 1 ;;
  esac
  echo "...found $# file(s) on command line, feeding them to $ME"
  $CAT $* | $ME
  exit 0
fi

$RM $T1* $T2 $T3* $T4*  # get rid of old files
$CAT  <<'EOA' > $T4         # create awk extract script
awk '
BEGIN { inhex = 0 ; part = 0 ; file = "" }
/^---/ {
  if ($2 == "start") {
    part++
    if (part < 10) {
      file = "T1" $6
      if (proc_files[file] == 1) {
        file = "T2"
      } else {
        proc_files[file] = 1
      }
    }
  }
  if (inhex && (NF > 1))
    inhex = 0
  else {
    inhex = 1
    getline
  }
}
{ if (inhex) print $0 > file }'
EOA

# Make awk script use process-specific filenames
$SED -e "s;T1;$T1;" -e "s;T2;$T2;" < $T4 > $T4"p"
$RM $T4
$MV $T4"p" $T4
# Invoke the awk script on std in:
echo ...extracting data...
. $T4
$CAT $T1* > $T3                # gather pieces
echo ...finished extraction, starting uudecode...
fname=`$HEAD -100 $T3 | $GREP begin | $SED 's/.* .* //'`
OurDir=`$PWD`
cd $TD
$touch $T3
chmod -f 777 $T3
$uudecode $T3
$RM  $T3
chmod -f 777 $fname
$MV $fname "$fname.$CE"
echo ...finished uudecode, starting uncompress...
$uncompress $fname.$CE
$MV $fname $OurDir
cd $OurDir
echo ...finished uncompress, starting tar extraction...
fname=`basename $fname`
$RM $T1*                      # tar returns no exit status!! Grrr.
$TA $TAO $fname 2>$T1         # check exit status of tar
if test -s $T1 ; then
  echo "... >>> Sigh <<<  $TA seems to be having problems:"
  $CAT $T1
  echo "...saving $TA archive in $fname."
else
  echo "...That's all folks!"
  $RM $fname
fi
$RM  $T1* $T2* $T3* $T4*
exit 0
!NO!SUBS!
chmod 755 joinr
$eunicefix joinr
